# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2010-2013 Elico Corp. All Rights Reserved.
#    Augustin Cisterne-Kaas <augustin.cisterne-kaaas@elico-corp.com>
#    Eric Caudal <eric.caudal@elico-corp.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    'name': 'Base Inter-Company',
    'version': '1.0',
    'author': 'Elico Corp',
    'website': 'http://www.elico-corp.com',
    'summary': '',
    'description': """
Inter-Company Processing (ICOPS)
This module is designed to manage Inter-company Process (ICOPS) and allow 2 companies to create objects in each other:
- When a PO to company B is created in company A, it creates automatically a SO in company B
- When a SO to company B is created in company A, it creates automatically a PO in company B
- Update PO from/to SO
- Confirm SO for PO and vice versa
- It is generic enough to allow intercompany process companies in cascade
- it can be uni-directional/bi-directional (eg SO in company A creates PO in company B and when the PO is validated in company B it validate the SO in company A).

Works fine with SO/PO
Under construction: Sales invoice/Purchase invoice and Stock Moves
Blueprint: https://blueprints.launchpad.net/multi-company/+spec/icops


    """,
    'depends': ['base', 'sale', 'stock',
                'sale_stock', 'purchase', 'account_cancel',
                'multi_company', ],
    'category': 'Sale',
    'sequence': 10,
    'demo': ['base_intercompany_demo.xml'],
    'data': [
        'company_view.xml',
        'sale_wkf.xml',
        'purchase_wkf.xml',
        #'stock_picking_wkf.xml',
        'security/intercompany_security.xml',
        'security/ir.model.access.csv'],
    'test': [],
    'installable': True,
    'application': False,
    'auto_install': False,
    'css': [],
}

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
