from openerp import SUPERUSER_ID
from openerp.osv import osv
from openerp.tools.translate import _
from openerp import netsvc


class icops_order(object):

    def __init__(self, obj):
        self.obj = obj
        self.obj2obj_1 = 'so2po'
        self.obj2obj_2 = 'po2so'
        self.attr_id_1 = 'purchase_id'
        self.attr_id_2 = 'sale_id'
        self.name_2 = 'purchase.order'
        self.confirm = 'purchase_confirm'
        if self.obj._name == 'purchase.order':
            self.confirm = 'order_confirm'
            self.obj2obj_1 = 'po2so'
            self.obj2obj_2 = 'so2po'
            self.name_2 = 'sale.order'
            self.attr_id_1 = 'sale_id'
            self.attr_id_2 = 'purchase_id'
        self.order_pool = self.obj.pool.get(self.name_2)

    def create_intercompany(self, cr, uid, ids, node='draft', context=None):
        ic_pool = self.obj.pool.get('res.intercompany')
        company_from, company_to, ic_uid = ic_pool.get_intercompany(
            cr, uid, ids[0], self.obj._name, self.obj2obj_1, context=context)
        if ic_pool.check_need_create_intercompany_object(
                cr, uid, company_from, company_to, self.obj2obj_1, node):
            self._create_intercompany(
                cr, uid, ids[0], company_to, ic_uid, context=context)
        return True

    def _create_intercompany(
            self, cr, uid, id, company_to, ic_uid, context=None):
        if isinstance(company_to, list):
            company_to = company_to[0]
        context = context or {}
        order = self.obj.read(cr, uid, id, ['partner_id'], context=context)
        company = self.obj.pool.get('res.company').read(
            cr, ic_uid, company_to, ['partner_id'], context=context)
        if order['partner_id'] != company['partner_id']:
            return None
        order_data = self.obj._prepare_IC(
            cr, uid, id, company_to,
            ic_uid, context=context)
        if not 'is_locked' in context:
            order_pool = self.obj.pool.get(self.name_2)
            res = order_pool.create(cr, ic_uid, order_data, context=context)
            data = {self.attr_id_1: res}
            self.obj.write(
                cr, uid, id, data, context=context)

            return res

    def action(self, cr, uid, ids, values=None, state='draft', context=None):
        if not isinstance(ids, list):
            ids = [ids]
        for order in self.obj.read(
                cr, uid, ids,
                ['company_id', self.attr_id_1], context=context):
            if not self.attr_id_1 in order:
                continue
            if values and 'state' in values:
                if values['state'] == 'cancel':
                    state = 'cancel'
                elif values['state'] == 'confirmed':
                    return
            company_pool = self.obj.pool.get('res.company')
            company = company_pool.read(
                cr, uid, order['company_id'][0],
                ['intercompany_ids'], context=context)
            self.loop(
                cr, uid, order['id'], company['intercompany_ids'], 'regular',
                self.obj2obj_1, state, context)
            company = None
            if not order[self.attr_id_1]:
                continue
            obj = self.obj.pool.get(self.name_2).read(
                cr, SUPERUSER_ID, order[self.attr_id_1][0],
                ['company_id'], context=context)
            if not obj:
                continue
            company = company_pool.read(
                cr, SUPERUSER_ID, obj['company_id'][0],
                ['intercompany_uid', 'intercompany_ids'], context=context)
            ic_uid = company['intercompany_uid'][0]
            self.loop(
                cr, ic_uid, obj['id'],
                company['intercompany_ids'], 'inverse', self.obj2obj_2,
                state, context=context)
        return True

    def loop(
            self, cr, uid, id, icops_ids,
            direction, obj2obj, state, context=None):

        order_pool = self.obj.pool.get(self.name_2)
        opposite_direction = 'inverse' if direction == 'regular' else 'regular'
        icops_pool = self.obj.pool.get('res.intercompany')
        ic_att = ['obj2obj', 'status', 'intercompany_uid', 'direction',
                  'company_to']
        for ic in icops_pool.read(cr, uid, icops_ids, ic_att, context=context):
            if ic['obj2obj'] != obj2obj or ic['status'] != state:
                continue

            ic_uid = ic['intercompany_uid'][0]
            ic_order_ids = order_pool.search(
                cr, ic_uid,
                [(self.attr_id_2, '=', id)], context=context)
            ic_order_id = ic_order_ids and ic_order_ids[0]
            if((ic['direction'] == direction
                    or ic['direction'] == 'bidirectional')
                or
                    ('force_update' in context)):
                context['is_external'] = True
                if state == 'draft':
                    data = self.obj._prepare_IC(
                        cr, uid, id, ic['company_to'][0], ic_uid,
                        context=context)
                    obj = order_pool.read(cr, ic_uid, ic_order_id, ['state'],
                                          context=context)
                    try:
                        if not isinstance(obj, dict):
                            continue
                        if obj['state'] == "progress" and 'order_line' in data:
                            data.pop('order_line')
                    except:
                        pass
                    order_pool.write(
                        cr, ic_uid, ic_order_id, data, context=context)
                elif state == 'cancel':

                    try:
                        order_pool.action_cancel(
                            cr, ic_uid, [ic_order_id], context=context)
                    except:
                        continue
                elif state == 'confirm':
                    if self.obj._name == 'purchase.order':
                        order_pool.action_wait(
                            cr, ic_uid, [ic_order_id], context=context)
                        continue
                    order_pool.wkf_confirm_order(
                        cr, ic_uid, [ic_order_id], context=context)
                elif state == 'unlink':
                    order_pool.unlink(
                        cr, SUPERUSER_ID, ic_order_id, context=context)

            elif(not 'is_external' in context and
                 ic['direction'] == opposite_direction):
                raise osv.except_osv(
                    _('Error!'),
                    _('You can\'t edit this %s mode quotation'
                        % opposite_direction))
